-- mein Mapviewer, anzeigen der PDA Map auf dem Bildschirm

mapviewer={};
mapviewer.moddir=g_currentModDirectory;

function mapviewer:load(xmlFile)
end;

function mapviewer:loadMap(name)
	self.mapvieweractive=false;
	self.maplegende = false;
	self.activePlayerNode=0;

	self.x=0;
	self.y=0;
	self.z=0;
	self.length=0;
	self.dX=0;
	self.dZ=0;
	self.l_PosY = 0;	--Legende Y Position
	self.TEntfernung=0;
	self.TRichtung=0;
	self.playerRotY=0;
	self.plyname = {};
	
	self.bigmap ={};
	self.bigmap.mapDimensionX = 2048;
	self.bigmap.mapDimensionY = 2048;
	self.bigmap.mapWidth = 1; 
	self.bigmap.mapHeight = 1; 
	self.bigmap.mapPosX = 0.5-(self.bigmap.mapWidth/2);
	self.bigmap.mapPosY = 0.5-(self.bigmap.mapHeight/2);
	self.bigmap.OverlayId = nil
	self.bigmap.OverlayId = createImageOverlay(Utils.getFilename("gfx/pda_map.png", self.moddir));
 
	
	--Array für Fahrzeugkoordinaten
	self.bigmap.IconSteerable = {};
	self.bigmap.IconSteerable.file = "";
	self.bigmap.IconSteerable.OverlayId = createImageOverlay(Utils.getFilename("icons/tractor.png", self.moddir));
	self.bigmap.IconSteerable.mpOverlayId = createImageOverlay(Utils.getFilename("icons/tractorctrl.png", self.moddir));
	self.bigmap.IconSteerable.width = 0.0078125;
	self.bigmap.IconSteerable.height = 0.0078125;
	self.bigmap.IconSteerable.Icon = {};
	
	--Array für Anbauten
	self.bigmap.IconAttachments = {};
	self.bigmap.IconAttachments.Icon = {front = {file = "", OverlayId = nil}, rear={file = "", OverlayId = nil}};
	self.bigmap.IconAttachments.Icon.front.file = Utils.getFilename("icons/feldgeraet.png", self.moddir); --Utils.getFilename("dataS2/missions/hud_pda_spot_shop.png");	
	self.bigmap.IconAttachments.Icon.front.OverlayId = createImageOverlay(self.bigmap.IconAttachments.Icon.front.file);
	self.bigmap.IconAttachments.Icon.rear.OverlayId = createImageOverlay(self.bigmap.IconAttachments.Icon.rear.file);
	self.bigmap.IconAttachments.width = 0.0078125; --16px
	self.bigmap.IconAttachments.height = 0.0078125; --16px
	
	--Array für Spielerinfos
	self.bigmap.player = {}; --
																	 
	self.bigmap.player.ArrowOverlayId = createImageOverlay(Utils.getFilename("icons/eigenerspieler.png", self.moddir));--g_currentMission.missionPDA.pdaPlayerMapArrow.overlayId;
	self.bigmap.player.mpArrowOverlayId = createImageOverlay(Utils.getFilename("icons/mpspieler.png", self.moddir));--g_currentMission.missionPDA.pdaPlayerMapArrow.overlayId;
	self.bigmap.player.name = ""; 
	self.bigmap.player.xPos	= 0;
	self.bigmap.player.xPosPDA	= g_currentMission.missionPDA.pdaMapPosX;
	self.bigmap.player.yPos = 0;
	self.bigmap.player.yPosPDA = g_currentMission.missionPDA.pdaMapPosX;	
	self.bigmap.player.width = 24/2048;
	self.bigmap.player.height = 24/2048
	
	--debug
	-- print("Name :" .. name);
	-- print("pdaMapPosX :" .. g_currentMission.missionPDA.pdaMapPosX);
	-- print("pdaMapPosY :" .. g_currentMission.missionPDA.pdaMapPosY);
	-- print("pdaCoordsXPos :" .. g_currentMission.missionPDA.pdaCoordsXPos);
	-- print("pdaCoordsYPos :" .. g_currentMission.missionPDA.pdaCoordsYPos);

end;

function mapviewer:deleteMap()
end;

function mapviewer:writeStream(streamId, connection)
end;

function mapviewer:readStream(streamId, connection)
end;

function mapviewer:mouseEvent(posX, posY, isDown, isUp, button)
end;

function mapviewer:keyEvent(unicode, sym, modifier, isDown)
	-- Taste 'm' für Map anzeigen
	--if sym == Input.MOD_CTRL and sym == Input.KEY_m then
	if isDown and sym == Input.KEY_m and bitAND(modifier, Input.MOD_ALT) > 0 then
	--if sym==109 and isDown then
		self.mapvieweractive=not self.mapvieweractive;
	end;
end;

function mapviewer:update(dt)
	if self.activePlayerNode == nil or self.activePlayerNode == 0 then
		if g_currentMission.player ~= nil then
			self.activePlayerNode=g_currentMission.player.rootNode;
		end;
	end;
end;

function mapviewer:draw()
	if self.mapvieweractive then
		if self.bigmap.OverlayId ~=nil then
			renderOverlay(self.bigmap.OverlayId, self.bigmap.mapPosX, self.bigmap.mapPosY, self.bigmap.mapWidth, self.bigmap.mapHeight);			
		else
			print("Kann 'self.bigmap.OverlayId' nicht erzeugen");
		end;

		mplayer = {};
		for key, value in pairs (g_currentMission.players) do
			mplayer.player = value;
			if mplayer.player.isControlled == false then
				posX = mplayer.player.lastXPos;
				posY = mplayer.player.lastYPos;
				posZ = posY;
			else
				posX, posY, posZ = getWorldTranslation(mplayer.player.rootNode);
			end;

			mplayer.xPos = ((((self.bigmap.mapDimensionX/2)+posX)/self.bigmap.mapDimensionX)*self.bigmap.mapWidth);--self.bigmap.player.xPosPDA+0.008;
			mplayer.yPos = ((((self.bigmap.mapDimensionY/2)-posZ)/self.bigmap.mapDimensionY)*self.bigmap.mapHeight);--self.bigmap.player.yPosPDA+0.003;
			setTextColor(0, 1, 0, 1);

			if mplayer.player.rootNode == self.activePlayerNode and mplayer.player.isControlled then
				renderOverlay(self.bigmap.player.ArrowOverlayId, 
								mplayer.xPos-self.bigmap.player.width/2, mplayer.yPos-self.bigmap.player.height/2,
								self.bigmap.player.width, self.bigmap.player.height);
				renderText(mplayer.xPos +self.bigmap.player.width/2, mplayer.yPos-self.bigmap.player.height/2, 0.015, mplayer.player.controllerName);
			elseif mplayer.player.isControlled then
				renderOverlay(self.bigmap.player.mpArrowOverlayId, 
								mplayer.xPos-self.bigmap.player.width/2, mplayer.yPos-self.bigmap.player.height/2, 
								self.bigmap.player.width, self.bigmap.player.height);
				renderText(mplayer.xPos +self.bigmap.player.width/2, mplayer.yPos-self.bigmap.player.height/2, 0.015, mplayer.player.controllerName);
			end;
			setTextColor(1, 1, 1, 0);
		end;
		
		--Hotspots auf grosse Karte
		for j=1, table.getn(g_currentMission.missionPDA.hotspots) do
			self.hsWidth = g_currentMission.missionPDA.hotspots[j].width;
			self.hsHeight = g_currentMission.missionPDA.hotspots[j].height;
			self.hsPosX = (g_currentMission.missionPDA.hotspots[j].xMapPos/2048)-(self.hsWidth/2);
			self.hsPosY = 1-(g_currentMission.missionPDA.hotspots[j].yMapPos/2048);--self.hsHeight;
			self.hsOverlayId = g_currentMission.missionPDA.hotspots[j].overlay.overlayId;
			renderOverlay(self.hsOverlayId, self.hsPosX, self.hsPosY, self.hsWidth, self.hsHeight);
				--debug
				-- print("Index HotSpots erzeugen:" .. j);
				-- print("self.hsWidth :" .. self.hsWidth);
				-- print("self.hsHeight :" .. self.hsHeight);
				-- print("self.hsPosX :" .. self.hsPosX);
				-- print("self.hsPosY :" .. self.hsPosY);
				-- print("self.hsOverlayId :" .. self.hsOverlayId);
		end;

		-- Fahrzeuge auf grosse Karte
		for i=1, table.getn(g_currentMission.steerables) do
			if not g_currentMission.steerables[i].isBroken then
				self.currentVehicle = g_currentMission.steerables[i];
				self.posX, self.posY, self.posZ = getWorldTranslation(self.currentVehicle.rootNode);
				self.buttonX = ((((self.bigmap.mapDimensionX/2)+self.posX)/self.bigmap.mapDimensionX)*self.bigmap.mapWidth);
				self.buttonZ = ((((self.bigmap.mapDimensionY/2)-self.posZ)/self.bigmap.mapDimensionY)*self.bigmap.mapHeight);
				
				setTextColor(0, 1, 0, 1);
				if self.currentVehicle.isControlled and self.currentVehicle.controllerName == self.plyname.name then
					
					renderOverlay(self.bigmap.IconSteerable.mpOverlayId,
									self.buttonX-self.bigmap.IconSteerable.width/2, 
									self.buttonZ-self.bigmap.IconSteerable.height/2,
									self.bigmap.IconSteerable.width,
									self.bigmap.IconSteerable.height);
					setOverlayColor(self.bigmap.IconSteerable.OverlayId, 1, 1, 1, 1);
					
					renderText(self.buttonX-0.025, self.buttonZ-self.bigmap.IconSteerable.height-0.01, 0.015, string.format("%s", self.plyname.name));
				elseif self.currentVehicle.isControlled then
					renderOverlay(self.bigmap.IconSteerable.mpOverlayId,
									self.buttonX-self.bigmap.IconSteerable.width/2, 
									self.buttonZ-self.bigmap.IconSteerable.height/2,
									self.bigmap.IconSteerable.width,
									self.bigmap.IconSteerable.height);
					setOverlayColor(self.bigmap.IconSteerable.OverlayId, 1, 1, 1, 1);
					renderText(self.buttonX-0.025, self.buttonZ-self.bigmap.IconSteerable.height-0.01, 0.015, string.format("%s", self.currentVehicle.controllerName));
				else
					renderOverlay(self.bigmap.IconSteerable.OverlayId,
									self.buttonX-self.bigmap.IconSteerable.width/2, 
									self.buttonZ-self.bigmap.IconSteerable.height/2,
									self.bigmap.IconSteerable.width,
									self.bigmap.IconSteerable.height);
					setOverlayColor(self.bigmap.IconSteerable.OverlayId, 1, 1, 1, 1);
				end;
				setTextColor(1, 1, 1,0);
			end;
		end;
		-----
		for i=1, table.getn(g_currentMission.attachables) do
			self.currentVehicle = g_currentMission.attachables[i];
			self.posX, self.posY, self.posZ = getWorldTranslation(self.currentVehicle.rootNode);
			self.buttonX = ((((self.bigmap.mapDimensionX/2)+self.posX)/self.bigmap.mapDimensionX)*self.bigmap.mapWidth);
			self.buttonZ = ((((self.bigmap.mapDimensionY/2)-self.posZ)/self.bigmap.mapDimensionY)*self.bigmap.mapHeight);
				renderOverlay(self.bigmap.IconAttachments.Icon.front.OverlayId,
								self.buttonX-self.bigmap.IconAttachments.width/2, 
								self.buttonZ-self.bigmap.IconAttachments.height/2,
								self.bigmap.IconAttachments.width,
								self.bigmap.IconAttachments.height);
				setOverlayColor(self.bigmap.IconAttachments.Icon.front.OverlayId, 1, 1, 1, 1);
		end;
		-----
	end;
	--Namen auf PDA anzeigen
		self.plyname.name = g_currentMission.player.controllerName;
		self.plyname.yPos = g_currentMission.missionPDA.pdaPlayerMapArrow.y - 0.003;
		self.plyname.xPos = g_currentMission.missionPDA.pdaPlayerMapArrow.x;
	if g_currentMission.missionPDA.showPDA == true and g_currentMission.missionPDA.screen==1 then
		setTextColor(256,256,256,1);
		setTextAlignment(RenderText.ALIGN_CENTER);
		renderText(self.plyname.xPos, self.plyname.yPos, 0.02, self.plyname.name);
		setTextAlignment(RenderText.ALIGN_LEFT);
	end;
	---------------------------
end;

addModEventListener(mapviewer);